SystemOrganization addCategory: #BichOS!
SystemOrganization addCategory: 'BichOS-Tests'!

TestCase subclass: #TestsAlimentos
	instanceVariableNames: 'roberta lugares1 inicio punto1 punto2 punto3 punto4 galletita pan alfajor zapatilla'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS-Tests'!

!TestsAlimentos methodsFor: 'as yet unclassified' stamp: 'as 10/6/2015 17:25'!
setUp
	roberta := Hormiga new.
	
	lugares1 := Set new.
	
	roberta lugaresDondeEstuvo: lugares1.
	
	inicio := Ubicacion new.
	inicio unidadesX: 1.
	inicio unidadesY: 1.
	
	punto1 := Ubicacion new.
	punto1 unidadesX: 1.
	punto1 unidadesY: 3.
	
	punto2 := Ubicacion new.
	punto2 unidadesX: 2.
	punto2 unidadesY: 1.
	
	punto3 := Ubicacion new.
	punto3 unidadesX: 5.
	punto3 unidadesY: 3.
	
	punto4 := Ubicacion new.
	punto4 unidadesX: 2.
	punto4 unidadesY: 3.
	
	galletita := Comida new.
	pan := Comida new.
	alfajor := Alfajor new.
	zapatilla := Comida new.
	
	galletita cantidadDeAlimento: 10000.
	pan cantidadDeAlimento: 2000.
	zapatilla cantidadDeAlimento: 0.
	
	roberta ubicacion: inicio.	
	galletita ubicacion: punto1.
	pan ubicacion: punto2.
	alfajor ubicacion: punto3.
	zapatilla ubicacion: punto4.
	
	alfajor agregarChips.! !

!TestsAlimentos methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 19:43'!
testExtraerAlimentoDeAlfajor
	roberta extraerAlimentoDe: alfajor.
	self assert:((alfajor cantidadDeAlimento)=159994).! !

!TestsAlimentos methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 19:36'!
testExtraerAlimentoDeGalletitaOreo
	roberta extraerAlimentoDe: galletita.
	self assert:((galletita cantidadDeAlimento)=9994).! !

!TestsAlimentos methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 19:41'!
testExtraerAlimentoDeMigaDePan
	roberta extraerAlimentoDe: pan.
	self assert:((pan cantidadDeAlimento)=1994).! !

!TestsAlimentos methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 19:42'!
testExtraerAlimentoDeZapatilla
	roberta extraerAlimentoDe: zapatilla.
	self assert:((roberta alimentoTransportado)=5).! !

TestCase subclass: #TestsDeRecorridos
	instanceVariableNames: 'roberta punto1 punto2 punto3 inicio lugaresDondeEstuvo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS-Tests'!

!TestsDeRecorridos methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 18:03'!
setUp
	roberta := Hormiga new.
	lugaresDondeEstuvo := Set new.
	roberta lugaresDondeEstuvo: lugaresDondeEstuvo.
	
	inicio := Ubicacion new.
	inicio unidadesX: 1.
	inicio unidadesY: 1.
	
	roberta ubicacion: inicio.
	
	punto1 := Ubicacion new.
	punto1 unidadesX: 1.
	punto1 unidadesY: 3.
	
	punto2 := Ubicacion new.
	punto2 unidadesX: 2.
	punto2 unidadesY: 1.
	
	punto3 := Ubicacion new.
	punto3 unidadesX: 5.
	punto3 unidadesY: 3.
	
	
	! !

!TestsDeRecorridos methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 18:02'!
testDistaciaCuandoVaDeinicioAPunto1yDespuesAPunto2
	roberta moveteA: punto1.
	roberta moveteA: punto2.
	self assert:((roberta distanciaRecorrida) = 4.23606797749979).! !

!TestsDeRecorridos methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 18:04'!
testDistanciaCuandoVaDeInicioAPunto1
	roberta moveteA: punto1.
	self assert: ((roberta distanciaRecorrida) = 2).
	! !

!TestsDeRecorridos methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 18:10'!
testDistanciaPromedioCuandoVaAPunto1yDespuesAPunto3
	roberta moveteA: punto1.
	roberta moveteA: punto3.
	self assert: ((roberta distanciaPromedioRecorrida)=3).! !

!TestsDeRecorridos methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 21:57'!
testLugaresDondeEstuvoCuandoVaDeInicioAPunto1yDespuesAPunto2
	roberta moveteA: punto1.
	roberta moveteA: punto2.
	self assertCollection: (roberta lugaresDondeEstuvo) equals: ({inicio. punto1.} as: (roberta lugaresDondeEstuvo) class)! !

TestCase subclass: #TestsHormiguero
	instanceVariableNames: 'roberta juancita petunia hormigas hormiguero origen lugares1 lugares2 lugares3 inicio punto1 punto2 punto3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS-Tests'!

!TestsHormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 19:02'!
setUp
	roberta := Hormiga new.
	juancita := Hormiga new.
	petunia := Hormiga new.
	
	hormigas := Set new.
	hormigas addAll: {roberta. juancita. petunia}.
	hormiguero := Hormiguero new.
	hormiguero hormigasQueTiene: hormigas.
	hormiguero deposito:0.
	
	origen := Ubicacion new.
	origen unidadesX: 0.
	origen unidadesY: 0.
	hormiguero ubicacion: origen.
	
	lugares1 := Set new.
	lugares2 := Set new.
	lugares3 := Set new.
	
	roberta lugaresDondeEstuvo: lugares1.
	juancita lugaresDondeEstuvo: lugares2.
	petunia lugaresDondeEstuvo: lugares3.
	
	inicio := Ubicacion new.
	inicio unidadesX: 1.
	inicio unidadesY: 1.
	
	punto1 := Ubicacion new.
	punto1 unidadesX: 1.
	punto1 unidadesY: 3.
	
	punto2 := Ubicacion new.
	punto2 unidadesX: 2.
	punto2 unidadesY: 1.
	
	punto3 := Ubicacion new.
	punto3 unidadesX: 5.
	punto3 unidadesY: 3.
	
	roberta ubicacion: inicio.	
	petunia ubicacion: punto1.
	juancita ubicacion: punto2.! !

!TestsHormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 19:14'!
testCantidadDeAlimentoEnDeposito
	hormiguero recaudarAlimento.
	roberta alimentoTransportado: 5.
	juancita alimentoTransportado: 8.
	petunia alimentoTransportado: 2.
	self assert:((hormiguero deposito)=15).! !

!TestsHormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 19:11'!
testCantidadDeAlimentoQueLlevan3Hormigas
	roberta alimentoTransportado: 3.
	self assert:((hormiguero cantidadDeAlimentoQueLlevan)=13).! !

!TestsHormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 19:09'!
testCantidadDeAlimentoTotalDepositoEn15y3Hormigas
	hormiguero deposito:15.
	self assert:((hormiguero cantidadDeAlimentoTotal)=30).! !

!TestsHormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 19:00'!
testCuantasHormigasTieneConAlgunasHormigas
	self assert:((hormiguero cantidadDeHormigas)=3).! !

!TestsHormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 18:59'!
testCuantasHormigasTieneUnHormigueroVacio
	hormiguero hormigasQueTiene: {  }.
	self assert:((hormiguero cantidadDeHormigas)=0).! !

!TestsHormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 19:21'!
testDistanciaRecorridaPor3Hormigas
	roberta moveteA: punto1.
	juancita moveteA: inicio.
	petunia moveteA: punto3.
	roberta moveteA: punto3.
	
	self assert: ((hormiguero distanciaRecorridaPorSusHormigas)=11).! !

!TestsHormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 19:12'!
testRecaudarAlimentoPara3Hormigas
	hormiguero recaudarAlimento.
	self assert:((roberta alimentoTransportado)=0).! !

TestCase subclass: #testsAlimentoTransportado
	instanceVariableNames: 'roberta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS-Tests'!

!testsAlimentoTransportado methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 16:47'!
setUp
	roberta := Hormiga new.! !

!testsAlimentoTransportado methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 16:47'!
testCuandoAlimentoTransportadoEs5
	self assert: (roberta alimentoTransportado = 5).! !

!testsAlimentoTransportado methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 16:59'!
testEstaAlLimiteSiLleva9mg
	roberta alimentoTransportado: 9.
	self assert: (roberta estaAlLimite).! !

!testsAlimentoTransportado methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 16:58'!
testNoEstaAlLimiteSiLleva5mg
	self assert:( roberta estaAlLimite not).! !

!testsAlimentoTransportado methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 16:57'!
testNoEstaAlLimiteSiNoLlevaNada
	roberta alimentoTransportado: 0.
	self assert: (roberta estaAlLimite not).! !

Object subclass: #Comida
	instanceVariableNames: 'cantidadDeAlimento ubicacion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!Comida commentStamp: '<historical>' prior: 0!
A Comida is xxxxxxxxx.

Instance Variables
	cantidadDeAlimento:		<Object>
	ubicacion:		<Object>

cantidadDeAlimento
	- xxxxx

ubicacion
	- xxxxx
!

Comida subclass: #Alfajor
	instanceVariableNames: 'chipsDeChocolate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!Alfajor commentStamp: '<historical>' prior: 0!
An Alfajor is xxxxxxxxx.

Instance Variables
	chipsDeChocolate:		<Object>

chipsDeChocolate
	- xxxxx
!

!Alfajor methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 19:31'!
agregarChips
	self cantidadDeAlimento: self cantidadDeAlimento * self chipsDeChocolate.! !

!Alfajor methodsFor: 'accessing' stamp: 'as 9/20/2015 23:16'!
chipsDeChocolate
	^ chipsDeChocolate! !

!Alfajor methodsFor: 'accessing' stamp: 'as 9/21/2015 19:30'!
chipsDeChocolate: unosChips
	chipsDeChocolate := unosChips.! !

!Alfajor methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 19:32'!
initialize
	self cantidadDeAlimento: 20000.
	self chipsDeChocolate: 8.! !

!Comida methodsFor: 'accessing' stamp: 'as 9/20/2015 23:11'!
cantidadDeAlimento
	^ cantidadDeAlimento! !

!Comida methodsFor: 'accessing' stamp: 'as 9/20/2015 23:11'!
cantidadDeAlimento: anObject
	cantidadDeAlimento := anObject! !

!Comida methodsFor: 'yerbamala' stamp: 'as 9/21/2015 16:05'!
perdeMasa: unaCantidad
	self cantidadDeAlimento: self cantidadDeAlimento - unaCantidad - 1.! !

!Comida methodsFor: 'yerbamala' stamp: 'as 10/6/2015 17:46'!
sePuedeExtraerAlimento
 	(self cantidadDeAlimento = 0) 
		ifTrue: [self error: 'No quedan restos en este alimento']
		ifFalse: [ ^true ]
		! !

!Comida methodsFor: 'accessing' stamp: 'as 9/20/2015 23:11'!
ubicacion
	^ ubicacion! !

!Comida methodsFor: 'accessing' stamp: 'as 9/20/2015 23:11'!
ubicacion: anObject
	ubicacion := anObject! !

Object subclass: #EstadoCansada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

Object subclass: #EstadoExaltada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

Object subclass: #EstadoNormal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

Object subclass: #Hormiga
	instanceVariableNames: 'alimentoTransportado estado lugaresDondeEstuvo distanciaRecorrida ubicacion cantidadDeViajes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!Hormiga commentStamp: '<historical>' prior: 0!
A Hormiga is xxxxxxxxx.

Instance Variables
	alimentoTransportado:		<Object>
	estado:		<Object>
	lugaresDondeEstuvo:		<Object>

alimentoTransportado
	- xxxxx

estado
	- xxxxx

lugaresDondeEstuvo
	- xxxxx
!

!Hormiga methodsFor: 'accessing' stamp: 'as 9/9/2015 22:37'!
alimentoTransportado
	^ alimentoTransportado! !

!Hormiga methodsFor: 'accessing' stamp: 'as 9/9/2015 22:44'!
alimentoTransportado: anObject
	alimentoTransportado := anObject! !

!Hormiga methodsFor: 'accessing' stamp: 'as 9/21/2015 18:01'!
cantidadDeViajes
	^ cantidadDeViajes! !

!Hormiga methodsFor: 'accessing' stamp: 'as 9/21/2015 18:01'!
cantidadDeViajes: anObject
	cantidadDeViajes := anObject! !

!Hormiga methodsFor: 'yerbabrava' stamp: 'as 9/21/2015 18:04'!
distanciaPromedioRecorrida
	^(self distanciaRecorrida / (self cantidadDeViajes)).! !

!Hormiga methodsFor: 'yerbabrava' stamp: 'as 9/14/2015 21:28'!
distanciaRecorrida
	^ distanciaRecorrida! !

!Hormiga methodsFor: 'accessing' stamp: 'as 9/14/2015 21:28'!
distanciaRecorrida: anObject
	distanciaRecorrida := anObject! !

!Hormiga methodsFor: 'yerbabrava' stamp: 'as 9/21/2015 19:07'!
entregarAlimentoA: unaUbicacion
	self alimentoTransportado: 0.
	self moveteA: unaUbicacion.
	! !

!Hormiga methodsFor: 'yerbabrava' stamp: 'as 9/21/2015 18:01'!
estaAlLimite
	^ ((self alimentoTransportado) >=9) & ((self alimentoTransportado) <=10).! !

!Hormiga methodsFor: 'accessing' stamp: 'as 9/9/2015 22:44'!
estado
	^ estado! !

!Hormiga methodsFor: 'accessing' stamp: 'as 9/9/2015 22:44'!
estado: anObject
	estado := anObject! !

!Hormiga methodsFor: 'yerbabrava' stamp: 'as 9/21/2015 19:40'!
extraerAlimentoDe: unaComida
	self moveteA: (unaComida ubicacion).
	((unaComida sePuedeExtraerAlimento) and: (self tengoLugar)) ifTrue:[
	unaComida perdeMasa: (10 - self alimentoTransportado).
	self alimentoTransportado: 10.].! !

!Hormiga methodsFor: 'yerbabrava' stamp: 'as 9/21/2015 18:03'!
initialize
	estado := 1.
	alimentoTransportado := 5.
	distanciaRecorrida := 0.
	cantidadDeViajes :=0.! !

!Hormiga methodsFor: 'yerbabrava' stamp: 'as 9/14/2015 21:22'!
lugaresDondeEstuvo
	^ lugaresDondeEstuvo! !

!Hormiga methodsFor: 'accessing' stamp: 'as 9/14/2015 21:22'!
lugaresDondeEstuvo: anObject
	lugaresDondeEstuvo := anObject! !

!Hormiga methodsFor: 'yerbabrava' stamp: 'as 9/21/2015 18:00'!
moveteA: unaUbicacion
	self lugaresDondeEstuvo add: self ubicacion.
	self distanciaRecorrida: ((self distanciaRecorrida) + ((self ubicacion) distanciaA: unaUbicacion)).
	self cantidadDeViajes: self cantidadDeViajes + 1.
	self ubicacion: unaUbicacion.
	
	! !

!Hormiga methodsFor: 'yerbabrava' stamp: 'as 9/21/2015 19:40'!
tengoLugar
	^((self alimentoTransportado) <=9).! !

!Hormiga methodsFor: 'accessing' stamp: 'as 9/21/2015 17:10'!
ubicacion
	^ ubicacion! !

!Hormiga methodsFor: 'accessing' stamp: 'as 9/21/2015 17:10'!
ubicacion: anObject
	ubicacion := anObject! !

!Hormiga methodsFor: 'accessing' stamp: 'as 9/14/2015 21:22'!
ubicacionActual
	^ ubicacionActual! !

!Hormiga methodsFor: 'accessing' stamp: 'as 9/14/2015 21:22'!
ubicacionActual: anObject
	ubicacionActual := anObject! !

Object subclass: #Hormiguero
	instanceVariableNames: 'hormigasQueTiene deposito ubicacion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!Hormiguero commentStamp: '<historical>' prior: 0!
A Hormiguero is xxxxxxxxx.

Instance Variables
	deposito:		<Object>
	hormigasQueTiene:		<Object>

deposito
	- xxxxx

hormigasQueTiene
	- xxxxx
!

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/9/2015 23:53'!
cantidadDeAlimentoQueLlevan
	^( self hormigasQueTiene sum:[: unaHormiga | unaHormiga alimentoTransportado.]).! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/9/2015 23:53'!
cantidadDeAlimentoTotal
	^(self deposito + self cantidadDeAlimentoQueLlevan).! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/9/2015 23:31'!
cantidadDeHormigas
	^( self hormigasQueTiene size).! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/9/2015 23:44'!
cantidadDeHormigasAlLimite
	^( (self hormigasQueTiene select:[: unaHormiga | unaHormiga estaAlLimite.]) size).! !

!Hormiguero methodsFor: 'accessing' stamp: 'as 9/9/2015 23:54'!
deposito
	^ deposito! !

!Hormiguero methodsFor: 'accessing' stamp: 'as 9/9/2015 23:54'!
deposito: anObject
	deposito := anObject! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/21/2015 19:17'!
distanciaRecorridaPorSusHormigas
	^self hormigasQueTiene sum:[:unaHormiga | unaHormiga distanciaRecorrida].! !

!Hormiguero methodsFor: 'accessing' stamp: 'as 9/9/2015 23:30'!
hormigasQueTiene
	^ hormigasQueTiene! !

!Hormiguero methodsFor: 'accessing' stamp: 'as 9/9/2015 23:30'!
hormigasQueTiene: anObject
	hormigasQueTiene := anObject! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'as 9/20/2015 23:30'!
recaudarAlimento
	self deposito: self deposito + self cantidadDeAlimentoQueLlevan.
	self hormigasQueTiene do:[: unaHormiga | unaHormiga entregarAlimentoA: (self ubicacion) ].
	! !

!Hormiguero methodsFor: 'accessing' stamp: 'as 9/14/2015 23:13'!
ubicacion
	^ ubicacion! !

!Hormiguero methodsFor: 'accessing' stamp: 'as 9/14/2015 23:13'!
ubicacion: anObject
	ubicacion := anObject! !

Object subclass: #Ubicacion
	instanceVariableNames: 'unidadesX unidadesY'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BichOS'!

!Ubicacion commentStamp: '<historical>' prior: 0!
An Ubicacion is xxxxxxxxx.

Instance Variables
	unidadesX:		<Object>
	unidadesY:		<Object>

unidadesX
	- xxxxx

unidadesY
	- xxxxx
!

!Ubicacion methodsFor: 'accessing' stamp: 'as 9/21/2015 17:33'!
distanciaA: otraUbicacion
	^((((self unidadesX - otraUbicacion unidadesX) raisedTo: 2) + ((self unidadesY - otraUbicacion unidadesY) raisedTo: 2)) sqrt).
! !

!Ubicacion methodsFor: 'accessing' stamp: 'as 9/14/2015 21:32'!
unidadesX
	^ unidadesX! !

!Ubicacion methodsFor: 'accessing' stamp: 'as 9/14/2015 21:32'!
unidadesX: anObject
	unidadesX := anObject! !

!Ubicacion methodsFor: 'accessing' stamp: 'as 9/14/2015 21:32'!
unidadesY
	^ unidadesY! !

!Ubicacion methodsFor: 'accessing' stamp: 'as 9/14/2015 21:32'!
unidadesY: anObject
	unidadesY := anObject! !
